local luajava = require("luajava")
  local SpeechRecognizer = luajava.bindClass("android.speech.SpeechRecognizer")
  local Intent = luajava.bindClass("android.content.Intent")
  local RecognizerIntent = luajava.bindClass("android.speech.RecognizerIntent")
  local Looper = luajava.bindClass("android.os.Looper")
  local Handler = luajava.bindClass("android.os.Handler")
  local activity = this
  local handler = Handler(Looper.getMainLooper())
  local vibrator = activity.getSystemService("vibrator")
  local recognizer = SpeechRecognizer.createSpeechRecognizer(activity)

  local function startVoiceRecognition(activity)
    local intent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
    intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
    intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, "ar")

    handler.postDelayed(function()
      vibrator.vibrate(50)
    end, 350)

    local recognitionListener = luajava.createProxy("android.speech.RecognitionListener", {
      onResults = function(params)
        local results = params.getStringArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
        local text = results.get(0)

        if text and text ~= "" then

             if text:lower() == "توقف" then
              this.postSpeak(200,"تم إيقافُ البحث. ")
              return


          elseif text == "تطبيق البريد" then
            service.click({{">BaridiMob"}})
            return
          elseif text == "تسجيل الدخول" then
            service.click({{"<#password#1", "%输入/12345", "#button",}})
            return

          elseif text == "التحويلات" then
            service.click({{"التحويلات|Transfers|Virements","كل انواع التعاملات|Other|Tous types de transactions>50","نحو حساب اخر*|To another account*|Virement Vers autre compte CCP*>50","مصدر التحويل*|From*|Source du virement*>60","*00799999*>50","#edit_value","%Dernier élément",}})
            return

          elseif text == "فليكسي موبيليس" then
            service.click({{"Paiements|Payments|المدفوعات","Tous types de transactions|كل انواع التعاملات|Other>50","Recharge mobile|شبكات الهاتف النقال>50","Mobilis>50","Source de l’opération*|مصدر العملية*|Source of payment>50","<Débit|الحساب المدين|Debit$100","%éléments suivants$200","%Cliquez","#edit_value_phone$200","%Dernier élément",}})
            return
          elseif text == "فليكسي جيزي" then
            service.click({{"Paiements|Payments|المدفوعات","Tous types de transactions|كل انواع التعاملات|Other>50","Recharge mobile|شبكات الهاتف النقال>50","Djezzy>50","Source de l’opération*|مصدر العملية*|Source of payment>50","<Débit|الحساب المدين|Debit$100","%éléments suivants$200","%Cliquez","#edit_value_phone$200","%Dernier élément",}})
            return
          elseif text == "فليكسي نجمه" then
            service.click({{"Paiements|Payments|المدفوعات","Tous types de transactions|كل انواع التعاملات|Other>50","Recharge mobile|شبكات الهاتف النقال>50","Ooredoo>50","Source de l’opération*|مصدر العملية*|Source of payment>50","<Débit|الحساب المدين|Debit$100","%éléments suivants$200","%Cliquez","#edit_value_phone$200","%Dernier élément",}})
            return


elseif text:lower() == "الجزائريه للمياه" then
service.click({{"Paiements|Payments|المدفوعات","Tous types de transactions|كل انواع التعاملات|Other>50","ADE|الجزائرية للمياه$100","#edit_value>50",}})
    return
elseif text:lower() == "الجزائريه للمياه الجديده" then
service.click({{"Paiements|Payments|المدفوعات","Tous types de transactions|كل انواع التعاملات|Other>50","SEAAL|سيال>50$100","#edit_value>50",}})
    return
elseif text:lower() == "اتصالات الجزائر" then
service.click({{"Paiements|Payments|المدفوعات","Tous types de transactions|كل انواع التعاملات|Other>50","Algérie Télécom|اتصالات الجزائر>50",}})
    return

          elseif text == "النماذج" then
            service.click({{"فتح القائمة|Ouvrir le menu|Open menu$100","النماذج|Modèles|Templates>10$100","<#cv#1>50",}})
            return
          elseif text == "تاكيد العمليات" then
            service.click({{"#continue_button","#text_get_code>30","#confirmation_code_otp>10","#android:id/icon1>30","#android:id/content>50","#confirm_button",}})
            return



elseif text:lower() == "المساعده" then
    print("إذا أردت أن تعدل على الأوامر حتى تتوافق معك، يمكنك أن تفتح الإضافة عن طريق المحرر ثم تنزل إلى الأسطر الخاصة بالشروط وتعدل عليها كما تشاء بين علامتي التنصيص. ويجب أن تكون متوافقة مع الإملاء الصوتي من جوجل والأفضل أن تكتبها عبر الإملاء الصوتي. يمكنك أن تعدل يدويًا بأن تحذف الفتحة والضمة والكسرة والسكون والشدة وتستبدل الهمزة فوق الألف والهمزة تحت الألف بالألف العادية، وكذلك يمكنك أن تستبدل التاء المربوطة بالهاء. ويجب عليك حذف علامات الترقيم ")
print("تطبيق البريد")
print("تسجيل الدخول ")
print("النماذج")
print("التحويلات")
print("فليكسي جيزي ")
print("فليكسي نجمة ")
print("فليكسي موبيليس ")
print("اتصالات الجزائر")
print("الجزائرية للمياه ")
print("الجزائرية للمياه الجديدة ")
print("تأكيد العمليات ")
return

           else
            this.postSpeak(200, "لا توجد خدمة متطابقة.")
          end
        end
      end,
      onError = function(error)
        this.postSpeak(200, "لم يتم التقاط أي نص.")
      end,
    })

    recognizer.setRecognitionListener(recognitionListener)
    recognizer.startListening(intent)
  end

service.speak("إخترِ الخدمةَ المناسِبة")
        local function checkSpeakingStatus()
          if not service.isSpeaking() then
startVoiceRecognition(activity)
          else
            handler.postDelayed(checkSpeakingStatus, 1000) -- إعادة التحقق بعد ثانية
          end
        end
        handler.postDelayed(checkSpeakingStatus, 1500) -- بدء التحقق بعد 1.5 ثانية

